package com.hisschemoller.controller 
{
	import com.hisschemoller.AppFacade;
	import com.hisschemoller.model.AudioEngineProxy;
	import com.hisschemoller.model.SampleBankProxy;
	import com.hisschemoller.model.audio.enum.AudioGeneratorTypes;
	import com.hisschemoller.model.audio.generators.PitchedSamplePlayer;
	import com.hisschemoller.model.vo.AudioEventVO;
	import com.hisschemoller.model.vo.SamplerPresetVO;
	import com.hisschemoller.utils.sound.SoundVO;
	
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 5, 2010
	 */
	public class GeneratorCommand extends SimpleCommand implements ICommand 
	{
		override public function execute(notification : INotification) : void
		{
			var audioEngineProxy : AudioEngineProxy = facade.retrieveProxy(AudioEngineProxy.NAME) as AudioEngineProxy;
			
			if(notification.getName() == AppFacade.ADD_GENERATOR)
			{
				var sampleBankProxy : SampleBankProxy = facade.retrieveProxy(SampleBankProxy.NAME) as SampleBankProxy;
				
				var samplerPresetVO : SamplerPresetVO = sampleBankProxy.selectedPreset;
				
				var generator : PitchedSamplePlayer = new PitchedSamplePlayer(0, samplerPresetVO.soundData.byteArray, samplerPresetVO.start, samplerPresetVO.end, samplerPresetVO.transpose);
				
				var audioEventVO : AudioEventVO = new AudioEventVO();
				audioEventVO.audioGenerator = generator;
				audioEventVO.channel == 0;
				audioEventVO.pitch = 60;
				audioEventVO.velocity = 100;
				audioEventVO.audioGeneratorType = AudioGeneratorTypes.PITCHED_SAMPLE_PLAYER;
				
				audioEngineProxy.addGenerator(audioEventVO);
			}
			else if(notification.getName() == AppFacade.REMOVE_GENERATOR)
			{
				audioEventVO = new AudioEventVO();
				audioEventVO.channel == 0;
				audioEventVO.pitch = 60;
				
				audioEngineProxy.removeGenerator(audioEventVO);
			}
		}
	}
}
