package com.hisschemoller.controller 
{
	import com.hisschemoller.AppFacade;
	import com.hisschemoller.model.AudioDriverProxy;
	import com.hisschemoller.model.SampleBankProxy;
	import com.hisschemoller.model.WaveDisplayProxy;
	import com.hisschemoller.model.vo.SamplerPresetVO;
	import com.hisschemoller.utils.sound.SoundVO;
	
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	import org.puremvc.as3.patterns.observer.Notifier;
	
	import flash.utils.ByteArray;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 10, 2010
	 */
	public class ReverseSampleCommand extends SimpleCommand implements ICommand
	{
		override public function execute(notification : INotification) : void
		{
			var reverse : Boolean = Boolean(notification.getBody());
			
			/** Stop the sound that currently plays (if there is any). */
			facade.sendNotification(AppFacade.REMOVE_GENERATOR);
			
			/** Get the preset and set reverse. */
			var sampleBankProxy : SampleBankProxy = facade.retrieveProxy(SampleBankProxy.NAME) as SampleBankProxy;	
			var samplerPresetVO : SamplerPresetVO = sampleBankProxy.selectedPreset;
			samplerPresetVO.reverse = reverse;
			
			/** Reverse the order of samples in samplerPresetVO.soundData.byteArray. */
			var bytesPerSample : int = AudioDriverProxy.BYTES_PER_SAMPLE;
			var numBytes : Number = samplerPresetVO.soundData.numSamplesTotal * bytesPerSample;
			var tempByteArray : ByteArray = new ByteArray();
			samplerPresetVO.soundData.byteArray.position = 0;
			tempByteArray.writeBytes(samplerPresetVO.soundData.byteArray);
			samplerPresetVO.soundData.byteArray.position = 0;
			
			for(var offset : Number = (numBytes - bytesPerSample); offset >= 0; offset -= bytesPerSample)
			{
				samplerPresetVO.soundData.byteArray.writeBytes(tempByteArray, offset, bytesPerSample);
			}
			
			/** Adjust the start and end point. */
			var newEnd : int = samplerPresetVO.soundData.numSamplesTotal - samplerPresetVO.start;
			samplerPresetVO.start = samplerPresetVO.soundData.numSamplesTotal - samplerPresetVO.end;
			samplerPresetVO.end = newEnd;
			
			/** Adjust the center of the zoom */
			var waveDisplayProxy : WaveDisplayProxy = WaveDisplayProxy(facade.retrieveProxy(WaveDisplayProxy.NAME));
			waveDisplayProxy.firstSampleInView = samplerPresetVO.soundData.numSamplesTotal - waveDisplayProxy.firstSampleInView - waveDisplayProxy.numSamplesInView;
			
			/** Update the display */
			waveDisplayProxy.forceUpdate();
		}
	}
}
