package com.hisschemoller.controller 
{
	import com.hisschemoller.App;
	import com.hisschemoller.AppFacade;
	import com.hisschemoller.model.AudioDriverProxy;
	import com.hisschemoller.model.AudioEngineProxy;
	import com.hisschemoller.model.SampleBankProxy;
	import com.hisschemoller.model.SampleEditorProxy;
	import com.hisschemoller.model.WaveDisplayProxy;
	import com.hisschemoller.view.LoadPanelMediator;
	import com.hisschemoller.view.SampleEditorMediator;
	import com.hisschemoller.view.ControlsMediator;
	import com.hisschemoller.view.WaveDisplayMediator;
	
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class StartupCommand extends SimpleCommand implements ICommand 
	{
		/**
		 * Register the Proxies and Mediators
		 */
		override public function execute(note : INotification) : void
		{
			// Create and register proxies
			facade.registerProxy(new AudioEngineProxy());
			facade.registerProxy(new AudioDriverProxy());
			facade.registerProxy(new WaveDisplayProxy());
			facade.registerProxy(new SampleBankProxy());
			facade.registerProxy(new SampleEditorProxy());
			
			// Create and register mediators
			var app : App = note.getBody() as App;
			facade.registerMediator(new WaveDisplayMediator(app._waveDisplay));
			facade.registerMediator(new LoadPanelMediator(app._loadPanel));
			facade.registerMediator(new SampleEditorMediator(app._sampleEditor));
			facade.registerMediator(new ControlsMediator(app._controls));
			
			// Start the application by loading a sound.
			facade.sendNotification(AppFacade.MP3_LOAD, "../mp3/music_is_here_to_stay.mp3");
		}
	}
}
