package com.hisschemoller.model 
{
	import com.hisschemoller.model.vo.SamplerPresetVO;
	import com.hisschemoller.utils.sound.SoundVO;
	
	import org.puremvc.as3.interfaces.IProxy;
	import org.puremvc.as3.patterns.proxy.Proxy;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class SampleBankProxy extends Proxy implements IProxy 
	{
		public static const NAME : String = "SampleBankProxy";
		public static const PRESET_CHANGED : String = 'presetChanged';
		private var _sounds : Vector.<SoundVO> = new Vector.<SoundVO>();
		private var _samplerPresets : Vector.<SamplerPresetVO> = new Vector.<SamplerPresetVO>();
		private var _selectedPreset : SamplerPresetVO;
		
		public function SampleBankProxy()
		{
			super(NAME);
		}
		
		/**
		 * 
		 */
		public function addSound(soundVO : SoundVO) : void
		{
			soundVO.numSamplesTotal = soundVO.sound.extract(soundVO.byteArray, (44100 * 60 * 60), 0);
			
			_sounds.push(soundVO);
		}
		
		/**
		 * 
		 */
		public function addPreset(soundVO : SoundVO) : SamplerPresetVO
		{
			var presetVO : SamplerPresetVO = new SamplerPresetVO();
			presetVO.soundData = soundVO;
			presetVO.start = 0;
			presetVO.end = presetVO.soundData.numSamplesTotal;
			
			_samplerPresets.push(presetVO);
			
			return presetVO;
		}
		
		/**
		 * 
		 */
		public function selectPresetBySoundVO(soundVO : SoundVO) : void
		{
			for(var i : int = 0; i < _samplerPresets.length; i++)
			{
				if(soundVO == _samplerPresets[i].soundData)
				{
					selectPreset(_samplerPresets[i]);
					break;
				}
			}
		}
		
		/**
		 * Select a preset:
		 * Tell the sample editor the sample changed. 
		 * Tell the display the sample changed. The settings for the display are adjusted. This causes the wave graphic to be updated.
		 * @param presetVO : The preset to select.
		 */
		public function selectPreset(presetVO : SamplerPresetVO) : void
		{
			_selectedPreset = presetVO;
			
			(facade.retrieveProxy(SampleEditorProxy.NAME) as SampleEditorProxy).changeSamplerPreset(_selectedPreset);
			
			(facade.retrieveProxy(WaveDisplayProxy.NAME) as WaveDisplayProxy).changeSamplerPreset(_selectedPreset);
			
			facade.sendNotification(SampleBankProxy.PRESET_CHANGED, _selectedPreset);
		}
		
		/**
		 * 
		 */
		public function get selectedPreset() : SamplerPresetVO
		{
			return _selectedPreset;
		}
	}
}
