package com.hisschemoller.model 
{
	import com.hisschemoller.model.vo.SamplerPresetVO;
	
	import org.puremvc.as3.interfaces.IProxy;
	import org.puremvc.as3.patterns.proxy.Proxy;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class SampleEditorProxy extends Proxy implements IProxy 
	{
		public static const NAME : String = "SampleEditorProxy";
		public static const SAMPLE_POSITIONS_CHANGED : String = "SamplePositionsChanged";
		public static const SAMPLE_TRANSPOSE_CHANGED : String = "SampleTransposeChanged";
		private var _presetVO : SamplerPresetVO;

		public function SampleEditorProxy()
		{
			super(NAME);
		}

		/**
		 * @param presetVO : SamplerPresetVO object with the sound to display
		 */
		public function changeSamplerPreset(presetVO : SamplerPresetVO) : void 
		{
			_presetVO = presetVO;
		}

		/**
		 * Adjust start position of the sample (for playback).
		 * @param startIndex : index of start sample
		 */
		public function set presetStart(startIndex : int) : void
		{
			_presetVO.start = startIndex;
			
			facade.sendNotification(SampleEditorProxy.SAMPLE_POSITIONS_CHANGED);
		}

		/**
		 * Adjust end position of the sample (for playback).
		 * @param endIndex : index of end sample
		 */
		public function set presetEnd(endIndex : int) : void
		{
			_presetVO.end = endIndex;
			
			facade.sendNotification(SampleEditorProxy.SAMPLE_POSITIONS_CHANGED);
		}

		/**
		 * Adjust start position of the sample (for playback).
		 * @param transpose : transpose value of the sample. Usually in semitones.
		 */
		public function set presetTranspose(transpose : Number) : void
		{
			_presetVO.transpose = transpose;
			
			facade.sendNotification(SampleEditorProxy.SAMPLE_TRANSPOSE_CHANGED);
		}
	}
}
