﻿package com.hisschemoller.utils.sound 
{
	import flash.events.Event;
	import flash.utils.getQualifiedClassName;	
	/**
	 * @author Wouter Hisschemöller
	 * (c) May 8, 2009
	 */
	public class SoundLoaderEvent extends Event 
	{
		/** Event type. */
		public static const _EVENT : String = "loaderStackEvent";
		/** Event subtype sent when a single object starts being loaded. */
		public static const START : String = "loadStart";
		/** Event subtype  sent during loading. */
		public static const PROGRESS : String = "loadProgress";
		/** Event subtype  sent when loading is done. */
		public static const COMPLETE : String = "loadDone";
		/** Event subtype  sent when all objects have been loaded. */
		public static const ALL_LOADED : String = "allLoadFinished";
		/** Event subtype  sent when there's an error. */
		public static const ERROR : String = "loadError";
		public var subtype : String;
		public var error : String;
		public var soundVO : SoundVO;

		/**
		 * Creates a new AssetLoaderEvent.
		 * @param inSubtype: either subtype; see above
		 * @param inName: (optional) identifier of the loading action
		 */
		public function SoundLoaderEvent(inSubtype : String, inSoundVO : SoundVO = null) 
		{
			super(_EVENT);
			
			subtype = inSubtype;
			soundVO = inSoundVO;
		}

		/**
		 * Creates a copy of an existing AssetLoaderEvent.
		 */
		public override function clone() : Event 
		{
			return new SoundLoaderEvent(subtype, soundVO);
		} 

		public override function toString() : String 
		{
			return getQualifiedClassName(this) + "; url=" + soundVO.url + "; subtype=" + subtype + "; error=" + error + "; totalBytesCount=" + soundVO.sound.bytesTotal + "; loadedBytesCount=" + soundVO.sound.bytesLoaded;
		}
	}
}