package com.hisschemoller.view.components 
{
	import assets.ControlsAsset;
	
	import com.hisschemoller.view.components.base.Component;
	import com.hisschemoller.view.components.base.KeyPushButton;
	import com.hisschemoller.view.components.base.PushButton;
	
	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.ui.Keyboard;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 5, 2010
	 */
	public class Controls extends Component 
	{
		public static const PLAY_PRESSED : String = "playPressed";
		public static const PLAY_RELEASED : String = "playReleased";
		private var _playButton : KeyPushButton;
		private var _helpButton : PushButton;
		private var _help : Help;

		public function Controls(container : DisplayObjectContainer)
		{
			super(container, new ControlsAsset());
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			_playButton = new KeyPushButton(asset.tPlayButton, Keyboard.SPACE);
			_playButton.addEventListener(MouseEvent.MOUSE_DOWN, playButtonEventHandler);
			_playButton.addEventListener(MouseEvent.MOUSE_UP, playButtonEventHandler);
			
			_helpButton = new PushButton(asset.tHelpButton);
			_helpButton.addEventListener(MouseEvent.CLICK, helpButtonEventHandler);
			
			_help = new Help(_asset.stage);
			_help.hide();
		}

		/**
		 * 
		 */
		private function playButtonEventHandler(inEvent : MouseEvent) : void
		{
			switch(inEvent.type)
			{
				case MouseEvent.MOUSE_DOWN:
					dispatchEvent(new Event(Controls.PLAY_PRESSED));
					break;
				case MouseEvent.MOUSE_UP:
					dispatchEvent(new Event(Controls.PLAY_RELEASED));
					break;
			}
		}

		/**
		 * 
		 */
		private function helpButtonEventHandler(inEvent : MouseEvent) : void
		{
			_help.show();
		}

		/**
		 * 
		 */
		private function get asset() : ControlsAsset
		{
			return _asset as ControlsAsset;
		}
	}
}
