package com.hisschemoller.view.components.base 
{
	import com.hisschemoller.view.components.base.PushButton;
	
	import flash.display.MovieClip;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;		
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 5, 2010
	 * 
	 * Adds keyboard control to the PushButton.
	 * A keycode is passed in the constructor and pressing the associated
	 * keyboard key is translated to mouse events.
	 */
	public class KeyPushButton extends PushButton 
	{
		private var _keyCode : uint;
		private var _keyDown : Boolean;
		
		public function KeyPushButton(inAsset : MovieClip, inKeyCode : uint)
		{
			_keyCode = inKeyCode;
			
			super(inAsset);
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			super.addChildren();
			
			_asset.stage.addEventListener(KeyboardEvent.KEY_DOWN, keyboardEventHandler);
			_asset.stage.addEventListener(KeyboardEvent.KEY_UP, keyboardEventHandler);
		}

		/**
		 * 
		 */
		private function keyboardEventHandler(inEvent : KeyboardEvent) : void
		{
			if(inEvent.keyCode == _keyCode)
			{
				switch(inEvent.type)
				{
					case KeyboardEvent.KEY_DOWN:
						if(!_keyDown) handleMouseDown(new MouseEvent(MouseEvent.MOUSE_DOWN));
						_keyDown = true;
						break;
					case KeyboardEvent.KEY_UP:
						handleMouseUp(new MouseEvent(MouseEvent.MOUSE_UP));
						handleMouseClick(new MouseEvent(MouseEvent.CLICK));
						_keyDown = false;
						break;
				}
			}
		}
	}
}
