package com.hisschemoller.view.components.base 
{
	import com.hisschemoller.view.components.base.Component;

	import flash.display.DisplayObjectContainer;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class PushButton extends Component 
	{
		protected static const LABEL_UP : String = "up";
		protected static const LABEL_OVER : String = "over";
		protected static const LABEL_DOWN : String = "down";
		protected var _enabled : Boolean;
		protected var _selected : Boolean;
		protected var _toggle : Boolean;
		protected var _mouseOver : Boolean;
		protected var _mouseDown : Boolean;

		public function PushButton(inAsset : MovieClip)
		{
			super(null, inAsset);
		}
		
		/**
		 * 
		 */
		public function get selected() : Boolean
		{
			return _selected;
		}
		
		/**
		 * 
		 */
		public function set selected(selected : Boolean) : void
		{
			_selected = selected;
			
			invalidate();
		}
		
		/**
		 * 
		 */
		public function get toggle() : Boolean
		{
			return _toggle;
		}
		
		/**
		 * 
		 */
		public function set toggle(toggle : Boolean) : void
		{
			if(!toggle && selected) selected = false;
			
			_toggle = toggle;
			
			if(_toggle) addEventListener(MouseEvent.CLICK, toggleSelected, false, 0, true);
			else removeEventListener(MouseEvent.CLICK, toggleSelected);
			
			invalidate();
		}
		
		/**
		 * 
		 */
		public function get enabled() : Boolean
		{
			return _enabled;
		}
		
		/**
		 * 
		 */
		public function set enabled(enabled : Boolean) : void
		{
			_enabled = enabled;
			
			invalidate();
		}

		/**
		 * Initializes the component.
		 */
		override protected function init() : void
		{
			super.init();
			
			_asset.stop();
			_asset.buttonMode = true;
			_asset.useHandCursor = true;
			_asset.mouseChildren = false;
			_asset.addEventListener(MouseEvent.CLICK, handleMouseClick);
		}

		/**
		 * Creates and adds the child display objects of this component.
		 */
		override protected function addChildren() : void
		{
			_asset.addEventListener(MouseEvent.ROLL_OVER, handleMouseOver);
			_asset.addEventListener(MouseEvent.MOUSE_DOWN, handleMouseDown);
		}
		
		/**
		 * 
		 */
		protected function toggleSelected(event : MouseEvent) : void
		{
			selected = !selected;
		}

		/**
		 * Internal mouseOver handler.
		 * @param inEvent The MouseEvent passed by the system.
		 */
		protected function handleMouseOver(inEvent : MouseEvent) : void
		{
			_mouseOver = true;
			_asset.gotoAndStop(PushButton.LABEL_OVER);
			_asset.addEventListener(MouseEvent.ROLL_OUT, handleMouseOut);
			dispatchEvent(new MouseEvent(MouseEvent.ROLL_OVER));
		}

		/**
		 * Internal mouseOut handler.
		 * @param inEvent The MouseEvent passed by the system.
		 */
		protected function handleMouseOut(inEvent : MouseEvent) : void
		{
			_mouseDown = false;
			
			if(!_mouseDown)
			{
				_asset.gotoAndStop(PushButton.LABEL_UP);
			}
		}

		/**
		 * Internal mouseOut handler.
		 * @param inEvent The MouseEvent passed by the system.
		 */
		protected function handleMouseDown(inEvent : MouseEvent) : void
		{
			_mouseDown = true;
			_asset.gotoAndStop(PushButton.LABEL_DOWN);
			_asset.stage.addEventListener(MouseEvent.MOUSE_UP, handleMouseUp);
			dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
		}

		/**
		 * Internal mouseUp handler.
		 * @param inEvent The MouseEvent passed by the system.
		 */
		protected function handleMouseUp(inEvent : MouseEvent) : void
		{
			_mouseDown = false;
			if(_mouseOver) _asset.gotoAndStop(PushButton.LABEL_OVER);
			else _asset.gotoAndStop(PushButton.LABEL_UP);
			_asset.stage.removeEventListener(MouseEvent.MOUSE_UP, handleMouseUp);
			
			dispatchEvent(new MouseEvent(MouseEvent.MOUSE_UP));
		}

		/**
		 * 
		 */
		protected function handleMouseClick(inEvent : MouseEvent) : void
		{
			dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
	}
}
